---
layout: book
section: documentation
category: manual
title: Usage
permalink: /docs/manual/usage
---
After TileMill is installed you will want to familiarize yourself with the basics of starting and stopping the app as well as configuring any relevant settings.

## Mac OS X

TileMill for Mac OS X is meant to be run as a desktop-style application.

- **Start** TileMill by double-clicking its icon in the `Applications` folder
- **Stop** TileMill by quitting the application
- **Files** used by TileMill are in your user account's `Documents/MapBox` folder
- **Logs** are viewable by choosing `Console` from the app's `Window` menu
- **Preferences** are available from the `TileMill` menu

## Ubuntu

- **Start** TileMill using the menu item at Applications > Graphics > TileMill.
- **Stop** TileMill by quitting the terminal window
- **Files** used by TileMill are in your user account's `Documents/MapBox` folder
- **Logs** are written to `~/.tilemill.log`
- **Preferences** can be changed by editing `~/.tilemill.json`

### Ubuntu preferences

TileMill configuration should be provided in JSON format. The configuration below, for example, tells the TileMill to listen on port 3001 and behave like a normal web server, allowing other users to access the application via LAN or the Internet:

    {
      "port": 3001,
      "listenHost": '0.0.0.0'
    }

The most commonly used options include:

- `port` the port that the server should listen on. Defaults to `8889`.
- `files` path to the files directory. Defaults to `~/Documents/MapBox`.
- `bufferSize` Mapnik render buffer size. Defaults to 128.
- `listenHost` Bind the server to the given host. Defaults to 127.0.0.1.
